package com.jenny.magic;

import com.jenny.magic.blocks.blocks;
import com.jenny.magic.blocks.entities.blockEntities;
import com.jenny.magic.conditions.conditions;
import com.jenny.magic.config.ConfigServer;
import com.jenny.magic.enchantments.enchantments;
import com.jenny.magic.entities.client.ProjectileBlocks;
import com.jenny.magic.entities.entities;
import com.jenny.magic.items.items;
import com.jenny.magic.networking.networking;
import com.jenny.magic.particles.particles;
import com.jenny.magic.sounds.sounds;
import com.mojang.logging.LogUtils;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.ModLoadingContext;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.config.ModConfig;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import org.slf4j.Logger;

// The value here should match an entry in the META-INF/mods.toml file
@Mod(Magic.MODID)
public class Magic {
    public static final String MODID = "magic";
    private static final Logger LOGGER = LogUtils.getLogger();

    public Magic() {
        IEventBus modEventBus = FMLJavaModLoadingContext.get().getModEventBus();
        MinecraftForge.EVENT_BUS.register(this);
        ModLoadingContext.get().registerConfig(ModConfig.Type.COMMON, ConfigServer.SPEC, "magic-server.toml");

        entities.register(modEventBus);
        items.register(modEventBus);
        blocks.register(modEventBus);
        ProjectileBlocks.register(modEventBus);
        blockEntities.register(modEventBus);
        enchantments.register(modEventBus);
        creativeTab.register(modEventBus);
        particles.register(modEventBus);
        sounds.register(modEventBus);
    }

    @Mod.EventBusSubscriber(modid = MODID, bus = Mod.EventBusSubscriber.Bus.MOD)
    public static class ModEvents {

        @SubscribeEvent
        public static void onClientSetup(FMLClientSetupEvent event) {
            entities.registerRenderers();
        }

        @SubscribeEvent
        public static void onCommonSetup(FMLCommonSetupEvent event) {
            conditions.register();
            networking.register();
        }
    }
}
