package com.jenny.magic.blocks.entities;

import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.monster.Monster;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.phys.AABB;

public class AntiSpawnerBE extends BlockEntity {
    protected final AABB area;

    public AntiSpawnerBE(BlockPos pPos, BlockState pBlockState) {
        super(blockEntities.ANTI_SPAWNER_BE.get(), pPos, pBlockState);
        area = new AABB(this.getBlockPos()).inflate(32);
    }

    public void tick(Level pLevel, BlockPos pPos, BlockState pState) {
        if (!pLevel.isClientSide) {
            for (Entity e : pLevel.getEntities(null, area)) {
                if (e instanceof Monster && ((Monster) e).getSpawnType() == MobSpawnType.NATURAL) {
                    e.remove(Entity.RemovalReason.KILLED);
                }
            }
        }
    }
}
