package com.jenny.magic.conditions;

import com.google.gson.JsonObject;
import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.common.ForgeConfigSpec;
import net.minecraftforge.common.crafting.conditions.ICondition;
import net.minecraftforge.common.crafting.conditions.IConditionSerializer;

import java.util.List;

import static com.jenny.magic.Magic.MODID;

public class ConfigCondition implements IConditionSerializer<ConfigCondition>, ICondition {
    public ForgeConfigSpec.ConfigValue<List<String>> list;
    public String name;

    public ConfigCondition(String name, ForgeConfigSpec.ConfigValue<List<String>> configListDisabled) {
        this.list = configListDisabled;
        this.name = name;
    }

    @Override
    public void write(JsonObject json, ConfigCondition value) {
    }

    @Override
    public ConfigCondition read(JsonObject json) {
        return this;
    }

    @Override
    public ResourceLocation getID() {
        return new ResourceLocation(MODID, name);
    }

    @Override
    public boolean test(IContext context) {
        return list.get().contains(name);
    }
}
