package com.jenny.magic.config;

import net.minecraftforge.common.ForgeConfigSpec;
import net.minecraftforge.fml.common.Mod;

import java.util.ArrayList;
import java.util.List;

import static com.jenny.magic.Magic.MODID;

@Mod.EventBusSubscriber(modid = MODID, bus = Mod.EventBusSubscriber.Bus.MOD)
public class ConfigServer {
    public static final ForgeConfigSpec SPEC;
    public static final ForgeConfigSpec.ConfigValue<Integer> C_TELEPORT_SCROLL_RANGE, C_TELEPORT_SCROLL_RANGE_RANDOM, C_BROADCAST_RANGE;
    public static final ForgeConfigSpec.ConfigValue<Boolean> C_PREVENT_BREAKING;
    public static final ForgeConfigSpec.ConfigValue<List<String>> C_DISABLED_LIST;
    private static final ForgeConfigSpec.Builder BUILDER = new ForgeConfigSpec.Builder();

    static {
        C_TELEPORT_SCROLL_RANGE =
                BUILDER.comment("maximum range for all targeted teleport scrolls; 0 = infinite")
                        .defineInRange("scroll_teleport_range", 0, 0, 60000000);
        C_TELEPORT_SCROLL_RANGE_RANDOM =
                BUILDER.comment("maximum range for all teleport scrolls with random targets")
                        .defineInRange("scroll_teleport_random_range", 30000000, 0, 30000000);
        C_DISABLED_LIST =
                BUILDER.comment("add any items (without mod ID) from this mod to this list to disable their recipes")
                        .define("disabled_items", defaultListDisabled());
        C_BROADCAST_RANGE =
                BUILDER.comment("up to which distance to send particle effects to players")
                        .defineInRange("scroll_teleport_random_range", 128, 1, 60000000);
        C_PREVENT_BREAKING =
                BUILDER.comment("prevent using wands with 1 durability to keep them from breaking")
                        .define("prevent_breaking", true);
        SPEC = BUILDER.build();
    }

    public static boolean isRecipeDisabled(String item) {
        return C_DISABLED_LIST.get().contains(item);
    }

    private static List<String> defaultListDisabled() {
        List<String> l = new ArrayList<>();
        l.add("item_1");
        l.add("item_2");
        return l;
    }
}
