package com.jenny.magic.enchantments;

import com.jenny.magic.items.wands.BaseWand;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import org.jetbrains.annotations.NotNull;

public class Homing extends Enchantment {

    protected Homing(Rarity pRarity, EnchantmentCategory pCategory, EquipmentSlot[] pApplicableSlots) {
        super(pRarity, pCategory, pApplicableSlots);
    }

    @Override
    public int getMaxLevel() {
        return 3;
    }

    @Override
    public boolean canEnchant(@NotNull ItemStack pStack) {
        return canApplyAtEnchantingTable(pStack) && isApplicableWand(pStack.getItem());
    }

    private boolean isApplicableWand(Item item) {
        return item instanceof BaseWand;
    }

    public boolean isTradeable() {
        return false;
    }

    public boolean isDiscoverable() {
        return false;
    }
}
