package com.jenny.magic.entities;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.phys.EntityHitResult;
import org.jetbrains.annotations.NotNull;

abstract class AreaProjectile extends BaseWandProjectile {
    private float range;

    protected AreaProjectile(EntityType<? extends AbstractArrow> pEntityType, Level pLevel, float range) {
        super(pEntityType, pLevel);
        this.range = range;
    }

    @Override
    protected void onHitEntity(@NotNull EntityHitResult pResult) {
        hit();
    }

    protected void hit() {
        for (Entity entity : level().getEntitiesOfClass(LivingEntity.class, new AABB(position().subtract(range, range, range), position().add(range, range, range)))) {
            hitLivingEntity(new EntityHitResult(entity));
            if (level().isClientSide) {
                hitParticles(entity);
            }
        }
    }

    @Override
    protected void onHitBlock(@NotNull BlockHitResult pResult) {
        hitBlock(pResult);
        hit();
        super.onHitBlock(pResult);
    }

}
