package com.jenny.magic.entities;

import com.jenny.magic.particles.particles;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.EntityHitResult;
import org.jetbrains.annotations.NotNull;

public class HurtfulProjectileAOE extends AreaProjectile {
    public HurtfulProjectileAOE(EntityType<? extends BaseWandProjectile> pEntityType, Level pLevel) {
        super(pEntityType, pLevel, 2);
    }

    public HurtfulProjectileAOE(Level pLevel) {
        super(entities.PROJECTILE_HURTFUL_AOE.get(), pLevel, 2);
    }

    @Override
    protected void hitLivingEntity(@NotNull EntityHitResult pResult) {
        if (pResult.getEntity() instanceof LivingEntity pLivng) {
            pResult.getEntity().hurt(getDamageSource(pResult), 3);
            this.doPostHurtEffects(pLivng);
        }
    }

    @Override
    public ParticleOptions particleFlying() {
        return particles.PARTICLE_FLYING_RED.get();
    }

    @Override
    public ParticleOptions particleHit() {
        return particles.PARTICLE_HIT_RED.get();
    }
}
