package com.jenny.magic.entities.client;

import com.jenny.magic.entities.BaseWandProjectile;
import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.math.Axis;
import net.minecraft.client.renderer.MultiBufferSource;
import net.minecraft.client.renderer.block.BlockRenderDispatcher;
import net.minecraft.client.renderer.entity.EntityRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.renderer.entity.TntMinecartRenderer;
import net.minecraft.client.renderer.texture.TextureAtlas;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.level.block.Block;
import org.jetbrains.annotations.NotNull;

public class BaseProjectileRenderer<T extends BaseWandProjectile> extends EntityRenderer<T> {
    private final BlockRenderDispatcher blockRenderer;
    private final Block block;

    public BaseProjectileRenderer(EntityRendererProvider.Context pContext, Block block) {
        super(pContext);
        this.blockRenderer = pContext.getBlockRenderDispatcher();
        this.block = block;
    }

    public void render(@NotNull T pEntity, float pEntityYaw, float pPartialTicks, @NotNull PoseStack pPoseStack, @NotNull MultiBufferSource pBuffer, int pPackedLight) {
        pPoseStack.pushPose();
        pPoseStack.mulPose(Axis.YP.rotationDegrees(-90.0F));
        pPoseStack.scale(pEntity.getBbWidth(), pEntity.getBbHeight(), pEntity.getBbWidth());
        pPoseStack.translate(-0.5F, 0, 0.5F);
        pPoseStack.mulPose(Axis.YP.rotationDegrees(90.0F));
        TntMinecartRenderer.renderWhiteSolidBlock(this.blockRenderer, block.defaultBlockState(), pPoseStack, pBuffer, pPackedLight, false);
        pPoseStack.popPose();
        super.render(pEntity, pEntityYaw, pPartialTicks, pPoseStack, pBuffer, pPackedLight);
    }

    @Override
    public @NotNull ResourceLocation getTextureLocation(T pEntity) {
        //return new ResourceLocation(MOD_ID, String.format("textures/entity/%s.png", pEntity.name()));
        return TextureAtlas.LOCATION_BLOCKS;
    }
}
