package com.jenny.magic.entities;

import com.jenny.magic.entities.client.BaseProjectileRenderer;
import com.jenny.magic.entities.client.ProjectileBlocks;
import net.minecraft.client.renderer.entity.EntityRenderers;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.MobCategory;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegistryObject;

import static com.jenny.magic.Magic.MODID;

public class entities {
    public static final DeferredRegister<EntityType<?>> ENTITY_TYPES =
            DeferredRegister.create(ForgeRegistries.ENTITY_TYPES, MODID);

    public static final RegistryObject<EntityType<BaseWandProjectile>> PROJECTILE_HURTFUL =
            ENTITY_TYPES.register("projectile_hurtful", () -> EntityType.Builder.<BaseWandProjectile>of(HurtfulProjectile::new, MobCategory.MISC)
                    .sized(0.3F, 0.3F).fireImmune().clientTrackingRange(8).build("projectile_hurtful"));

    public static final RegistryObject<EntityType<BaseWandProjectile>> PROJECTILE_HURTFUL_AOE =
            ENTITY_TYPES.register("projectile_hurtful_aoe", () -> EntityType.Builder.<BaseWandProjectile>of(HurtfulProjectileAOE::new, MobCategory.MISC)
                    .sized(0.3F, 0.3F).fireImmune().clientTrackingRange(8).build("projectile_hurtful_aoe"));

    public static void register(IEventBus eventBus) {
        ENTITY_TYPES.register(eventBus);
    }

    public static void registerRenderers() {
        EntityRenderers.register(PROJECTILE_HURTFUL.get(), (context) -> new BaseProjectileRenderer<>(context, ProjectileBlocks.PROJECTILE_HURTFUL.get()));
        EntityRenderers.register(PROJECTILE_HURTFUL_AOE.get(), (context) -> new BaseProjectileRenderer<>(context, ProjectileBlocks.PROJECTILE_HURTFUL_AOE.get()));

    }
}
