package com.jenny.magic.items.amulets;

import net.minecraft.ChatFormatting;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class AmuletBase extends com.jenny.magic.items.scrolls.SingleActionScroll {
    public AmuletBase(Properties pProperties) {
        super(pProperties.stacksTo(1));
    }

    public static boolean isEnabled(CompoundTag tag) {
        if (tag != null && tag.contains("amulet_enabled") && tag.getString("amulet_enabled").equals("false")) {
            return false;
        } else {
            return true;
        }
    }

    public static CompoundTag setEnabled(CompoundTag tag, boolean b) {
        tag.putString("amulet_enabled", Boolean.toString(b));
        return tag;
    }

    protected void use(Vec3 pos, Player player, @NotNull ItemStack itemStack, Level level) {
        CompoundTag tag = itemStack.getTag();
        if (tag == null) {
            tag = new CompoundTag();
        }
        itemStack.setTag(setEnabled(tag, !isEnabled(tag)));
    }

    @Override
    public Component getName(@NotNull ItemStack pStack) {
        if (!isEnabled(pStack.getTag())) {
            return Component.translatable(this.getDescriptionId(pStack)).withStyle(ChatFormatting.GRAY);
        } else {
            return Component.translatable(this.getDescriptionId(pStack));
        }
    }
}
