package com.jenny.magic.items.amulets;

import net.minecraft.core.BlockPos;
import net.minecraft.core.Vec3i;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.BoneMealItem;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.Level;
import org.jetbrains.annotations.NotNull;

public class AmuletBonemeal extends AmuletBase {
    protected static int chance = 10;

    public AmuletBonemeal(Properties pProperties) {
        super(pProperties);
    }

    protected static BlockPos getLocation(Player player) {
        return player.blockPosition().offset(new Vec3i(player.level().getRandom().nextIntBetweenInclusive(-5, 5), 0, player.level().getRandom().nextIntBetweenInclusive(-5, 5)));
    }

    @Override
    public void inventoryTick(@NotNull ItemStack pStack, @NotNull Level pLevel, @NotNull Entity pEntity, int pSlotId, boolean pIsSelected) {
        if (!pLevel.isClientSide && isEnabled(pStack.getTag()) && pLevel.getRandom().nextInt(chance) == 0 && pEntity instanceof Player pPlayer) {
            BoneMealItem.applyBonemeal(new ItemStack(Items.BONE_MEAL), pLevel, getLocation(pPlayer), pPlayer);
        }
    }
}