package com.jenny.magic.items.amulets;

import net.minecraft.world.effect.MobEffect;
import net.minecraft.world.effect.MobEffectInstance;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import org.jetbrains.annotations.NotNull;

import java.util.Optional;

public class AmuletEffect extends AmuletBase {
    private MobEffect effect;
    private int delay, duration, amplifier, tick;

    public AmuletEffect(Properties pProperties, MobEffect effect, int delay, int duration, int amplifier) {
        super(pProperties);
        this.effect = effect;
        this.delay = delay;
        this.duration = duration;
        this.amplifier = amplifier;
        this.tick = 0;
    }

    @Override
    public void inventoryTick(@NotNull ItemStack pStack, @NotNull Level pLevel, @NotNull Entity pEntity, int pSlotId, boolean pIsSelected) {
        if (!pLevel.isClientSide && isEnabled(pStack.getTag()) && tick % delay == 0) {
            if (pEntity instanceof LivingEntity p) {
                p.addEffect(new MobEffectInstance(effect, duration, amplifier, true, true, true, null, Optional.empty()));
            }
        }
        tick++;
    }
}
