package com.jenny.magic.items.amulets;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.AABB;
import org.jetbrains.annotations.NotNull;

public class AmuletSuction extends AmuletBase {
    private int delay, tick;
    private float range, power;

    public AmuletSuction(Properties pProperties, int delay, float range, float power) {
        super(pProperties);
        this.delay = delay;
        this.range = range;
        this.power = power;
        this.tick = 0;
    }

    @Override
    public void inventoryTick(@NotNull ItemStack pStack, @NotNull Level pLevel, @NotNull Entity pEntity, int pSlotId, boolean pIsSelected) {
        if (this.tick % this.delay == 0 && isEnabled(pStack.getTag())) {
            for (Entity drop : pLevel.getEntitiesOfClass(ItemEntity.class, new AABB(pEntity.position(), pEntity.position()).inflate(range), (itemEntity) -> true)) {
                drop.addDeltaMovement(pEntity.position().subtract(drop.position()).normalize().scale(power));
            }
        }
        tick++;
    }
}
