package com.jenny.magic.items;

import com.jenny.magic.entities.entities;
import com.jenny.magic.items.amulets.*;
import com.jenny.magic.items.scrolls.*;
import com.jenny.magic.items.wands.*;
import net.minecraft.ChatFormatting;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.world.item.Item;
import net.minecraft.world.level.biome.Biomes;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegistryObject;

import static com.jenny.magic.Magic.MODID;

public class items {
    public static final DeferredRegister<Item> ITEMS = DeferredRegister.create(ForgeRegistries.ITEMS, MODID);
    // WANDS
    public static final RegistryObject<Item> WAND_HURTFUL = ITEMS.register("wand_hurtful", () -> new ProjectileWand(new Item.Properties(), entities.PROJECTILE_HURTFUL));
    public static final RegistryObject<Item> WAND_HURTFUL_AOE = ITEMS.register("wand_hurtful_aoe", () -> new ProjectileWand(new Item.Properties(), entities.PROJECTILE_HURTFUL_AOE));
    public static final RegistryObject<Item> WAND_VACUUM = ITEMS.register("wand_vacuum", () -> new WandVacuum(new Item.Properties()));
    public static final RegistryObject<Item> WAND_BOOST = ITEMS.register("wand_boost", () -> new WandBoost(new Item.Properties()));
    public static final RegistryObject<Item> WAND_PUSH = ITEMS.register("wand_push", () -> new WandPush(new Item.Properties()));
    public static final RegistryObject<Item> WAND_ATTRACTION = ITEMS.register("wand_attraction", () -> new WandAttraction(new Item.Properties()));
    // SCROLLS
    public static final RegistryObject<Item> SCROLL_TELEPORT = ITEMS.register("scroll_teleport", () -> new ScrollTeleportPersistent(new Item.Properties().stacksTo(1)));
    public static final RegistryObject<Item> SCROLL_TELEPORT_BRITTLE = ITEMS.register("scroll_teleport_brittle", () -> new ScrollTeleportConsumable(new Item.Properties().stacksTo(16)));
    public static final RegistryObject<Item> SCROLL_TELEPORT_RANDOM = ITEMS.register("scroll_teleport_random", () -> new TeleportScrollRandom(new Item.Properties().stacksTo(1)));
    public static final RegistryObject<Item> SCROLL_TELEPORT_BIOME_PLAINS = ITEMS.register("scroll_teleport_biome_plains", () -> new ScrollTeleportBiome(new Item.Properties().stacksTo(16), Biomes.PLAINS, ChatFormatting.GREEN));
    public static final RegistryObject<Item> SCROLL_HEALTH = ITEMS.register("scroll_health", () -> new ScrollHealth(new Item.Properties().stacksTo(16)));
    public static final RegistryObject<Item> SCROLL_REPEL = ITEMS.register("scroll_repel", () -> new ScrollRepel(new Item.Properties().stacksTo(16)));
    public static final RegistryObject<Item> SCROLL_BONEMEAL = ITEMS.register("scroll_bonemeal", () -> new ScrollBonemeal(new Item.Properties().stacksTo(16)));
    // AMULETS
    public static final RegistryObject<Item> AMULET_REPAIR = ITEMS.register("amulet_repair", () -> new AmuletRepair(new Item.Properties()));
    public static final RegistryObject<Item> AMULET_BREATHING = ITEMS.register("amulet_breathing", () -> new AmuletEffect(new Item.Properties(), MobEffects.WATER_BREATHING, 200, 500, 1));
    public static final RegistryObject<Item> AMULET_NIGHTVISION = ITEMS.register("amulet_nightvision", () -> new AmuletEffect(new Item.Properties(), MobEffects.NIGHT_VISION, 200, 500, 1));
    public static final RegistryObject<Item> AMULET_SATURATION = ITEMS.register("amulet_saturation", () -> new AmuletEffect(new Item.Properties(), MobEffects.SATURATION, 200, 500, 1));
    public static final RegistryObject<Item> AMULET_SUCTION = ITEMS.register("amulet_suction", () -> new AmuletSuction(new Item.Properties(), 3, 4, 0.5f));
    public static final RegistryObject<Item> AMULET_BONEMEAL = ITEMS.register("amulet_bonemeal", () -> new AmuletBonemeal(new Item.Properties()));
    public static final RegistryObject<Item> AMULET_GOLD = ITEMS.register("amulet_gold", () -> new Item(new Item.Properties()));
    public static final RegistryObject<Item> AMULET_IMMUNITY = ITEMS.register("amulet_immunity", () -> new AmuletImmunity(new Item.Properties()));
    public static void register(IEventBus bus) {
        ITEMS.register(bus);
    }
}
