package com.jenny.magic.items.scrolls;

import com.jenny.magic.networking.networking;
import com.jenny.magic.networking.packets.EffectS2C;
import com.jenny.magic.particles.effects;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.BoneMealItem;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class ScrollBonemeal extends SingleActionScroll {
    public ScrollBonemeal(Item.Properties pProperties) {
        super(pProperties);
    }

    @Override
    protected void use(Vec3 pos, Player player, @NotNull ItemStack itemStack, @NotNull Level level) {
        if (!level.isClientSide) {
            boolean flag = false;
            for (int x = -5; x <= 5; x++) {
                for (int z = -5; z <= 5; z++) {
                    if (BoneMealItem.applyBonemeal(new ItemStack(Items.BONE_MEAL), level, player.blockPosition().offset(x, 0, z), player)) {
                        flag = true;
                        BoneMealItem.applyBonemeal(new ItemStack(Items.BONE_MEAL), level, player.blockPosition().offset(x, 0, z), player);
                    }
                }
            }
            if (flag) {
                networking.sendToClose(new EffectS2C(effects.EFFECT.SCROLL_BONEMEAL, player.position().add(0, player.getEyeHeight(), 0)), (ServerLevel) level);
                itemStack.shrink(1);
            }
        }
    }
}
