package com.jenny.magic.items.scrolls;

import com.jenny.magic.networking.networking;
import com.jenny.magic.networking.packets.EffectS2C;
import com.jenny.magic.particles.effects;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class ScrollHealth extends SingleActionScroll {
    public ScrollHealth(Item.Properties pProperties) {
        super(pProperties);
    }

    @Override
    protected void use(Vec3 pos, Player player, @NotNull ItemStack itemStack, Level level) {
        if (!level.isClientSide) {
            if (player.getMaxHealth() != player.getHealth()) {
                player.heal(5);
                itemStack.shrink(1);
                networking.sendToClose(new EffectS2C(effects.EFFECT.SCROLL_HEALTH, player.position().add(0, player.getEyeHeight(), 0)), (ServerLevel) level);
            }
        }
    }
}
