package com.jenny.magic.items.scrolls;

import com.jenny.magic.networking.networking;
import com.jenny.magic.networking.packets.EffectS2C;
import com.jenny.magic.particles.effects;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class ScrollRepel extends SingleActionScroll {
    public ScrollRepel(Item.Properties pProperties) {
        super(pProperties);
    }

    @Override
    protected void use(Vec3 pos, Player player, @NotNull ItemStack itemStack, @NotNull Level level) {
        if (!level.isClientSide) {
            boolean flag = false;
            for (Entity e : level.getEntitiesOfClass(LivingEntity.class, player.getBoundingBox().inflate(5, 2, 5))) {
                if (e.is(player)) {
                    continue;
                }
                e.addDeltaMovement(e.position().subtract(player.position()).normalize().scale(5 * e.position().subtract(player.position()).length()).multiply(1, 0, 1));
                flag = true;
                networking.sendToPlayer(new EffectS2C(effects.EFFECT.SCROLL_REPEL, e.position().add(0, e.getEyeHeight(), 0)), (ServerPlayer) player);
            }
            if (flag) {
                itemStack.shrink(1);
            }
        }
    }
}
