package com.jenny.magic.items.wands;

import com.jenny.magic.entities.BaseWandProjectile;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.Level;
import net.minecraftforge.registries.RegistryObject;
import org.jetbrains.annotations.NotNull;

public class ProjectileWand extends BaseWand {
    private RegistryObject<EntityType<BaseWandProjectile>> projectile;

    public ProjectileWand(Properties p_41383_, RegistryObject<EntityType<BaseWandProjectile>> projectile) {
        super(p_41383_);
        this.projectile = projectile;
    }

    @Override
    public @NotNull InteractionResultHolder<ItemStack> use(@NotNull Level pLevel, Player pPlayer, @NotNull InteractionHand pUsedHand) {
        ItemStack itemstack = pPlayer.getItemInHand(pUsedHand);
        if (tryUse(itemstack, pPlayer)) {
            BaseWandProjectile projectile = newProjectile(pLevel);
            projectile.shootFromRotation(pPlayer, pPlayer.getXRot(), pPlayer.getYRot(), 0.0F, 2.0F);
            pLevel.addFreshEntity(projectile);
            return InteractionResultHolder.success(itemstack);
        }
        return InteractionResultHolder.pass(itemstack);
    }

    @Override
    public boolean isValidRepairItem(@NotNull ItemStack pStack, @NotNull ItemStack pRepairCandidate) {
        if (pRepairCandidate.getItem().getDescriptionId().equals(Items.DIAMOND.getDescriptionId())) {
            while (pRepairCandidate.getCount() >= 1 && pStack.isDamaged()) {
                pRepairCandidate.shrink(1);
                pStack.setDamageValue(pStack.getDamageValue() - 20);
            }
            return true;
        } else {
            return false;
        }
    }

    BaseWandProjectile newProjectile(Level level) {
        return (BaseWandProjectile) projectile.get().create(level);
    }
}
