package com.jenny.magic.items.wands;

import com.jenny.magic.items.scrolls.ScrollTeleportRandom;
import com.jenny.magic.networking.networking;
import com.jenny.magic.networking.packets.EffectS2C;
import com.jenny.magic.particles.effects;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class WandVacuum extends ScrollTeleportRandom {
    public WandVacuum(Properties pProperties) {
        super(pProperties);
    }

    @Override
    public @NotNull InteractionResultHolder<ItemStack> use(@NotNull Level pLevel, @NotNull Player pPlayer, @NotNull InteractionHand pUsedHand) {
        use(pPlayer.position(), pPlayer, pPlayer.getItemInHand(pUsedHand), pLevel);
        return InteractionResultHolder.success(pPlayer.getItemInHand(pUsedHand));
    }

    @Override
    public @NotNull InteractionResult useOn(@NotNull UseOnContext pContext) {
        use(pContext.getClickedPos().getCenter().add(0, 0.5, 0), pContext.getPlayer(), pContext.getItemInHand(), pContext.getLevel());
        return InteractionResult.SUCCESS;
    }

    protected void use(Vec3 pos, Player player, @NotNull ItemStack itemStack, @NotNull Level level) {
        if (!level.isClientSide) {
            AABB aabb = new AABB(player.position().subtract(20, 20, 20), player.position().add(20, 20, 20));
            for (ItemEntity e : level.getEntitiesOfClass(ItemEntity.class, aabb)) {
                e.playerTouch(player);
            }
            networking.sendToPlayer(new EffectS2C(effects.EFFECT.WAND_VACUUM, player.position()), (ServerPlayer) player);
        }
    }
}
