package com.jenny.magic.mixins;

import com.jenny.magic.items.items;
import com.jenny.magic.util.util;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(net.minecraft.world.entity.monster.piglin.PiglinAi.class)
public class PiglinAi {
    @Inject(method = "isWearingGold", at = @At("RETURN"), cancellable = true)
    private static void isWearingGold(LivingEntity pLivingEntity, CallbackInfoReturnable<Boolean> cir) {
        if (pLivingEntity instanceof Player player && util.hasItem(player, items.AMULET_GOLD.get())) {
            cir.setReturnValue(true);
        }
    }
}
