package com.jenny.magic.mixins;

import com.jenny.magic.items.items;
import com.jenny.magic.items.wands.BaseWand;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.PathfinderMob;
import net.minecraft.world.item.ItemStack;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(net.minecraft.world.entity.ai.goal.TemptGoal.class)
public abstract class TemptGoal {
    @Shadow
    @Final
    protected PathfinderMob mob;

    @Unique
    private static @Nullable ItemStack getStack(@NotNull LivingEntity livingEntity) {
        if (livingEntity.getItemInHand(InteractionHand.MAIN_HAND).getItem().asItem().equals(items.WAND_ATTRACTION.get())) {
            return livingEntity.getItemInHand(InteractionHand.MAIN_HAND);
        } else {
            if (items.WAND_ATTRACTION.get().equals(livingEntity.getItemInHand(InteractionHand.OFF_HAND).getItem().asItem())) {
                return livingEntity.getItemInHand(InteractionHand.OFF_HAND);
            }
        }
        return null;
    }

    /**
     * @author xJenny69
     * @reason Attraction Wand
     */
    @Inject(method = "shouldFollow", at = @At("RETURN"), cancellable = true)
    private void shouldFollow(LivingEntity livingEntity, CallbackInfoReturnable<Boolean> cir) {
        ItemStack itemStack = getStack(livingEntity);
        if (itemStack != null) {
            boolean usable = true;
            if (livingEntity.level().getRandom().nextInt(30) == 0 && livingEntity.distanceTo(mob) < 10f) {
                usable = BaseWand.tryUse(itemStack, livingEntity);
            }
            if (usable) {
                cir.setReturnValue(true);
            }
        }
    }
}
