package com.jenny.magic.networking;

import com.jenny.magic.config.ConfigServer;
import com.jenny.magic.networking.packets.EffectS2C;
import com.jenny.magic.networking.packets.ManaAmountS2C;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.server.level.ServerPlayer;
import net.minecraftforge.network.NetworkDirection;
import net.minecraftforge.network.NetworkRegistry;
import net.minecraftforge.network.PacketDistributor;
import net.minecraftforge.network.simple.SimpleChannel;

import java.util.function.Predicate;

import static com.jenny.magic.Magic.MODID;

public class networking {
    private static SimpleChannel INSTANCE;
    private static int packetID = 0;

    private static int id() {
        return packetID;
    }

    public static void register() {
        SimpleChannel net = NetworkRegistry.ChannelBuilder
                .named(new ResourceLocation(MODID, "messages"))
                .networkProtocolVersion(() -> "1.0")
                .clientAcceptedVersions(s -> true)
                .serverAcceptedVersions(s -> true)
                .simpleChannel();
        INSTANCE = net;

        net.messageBuilder(ManaAmountS2C.class, id(), NetworkDirection.PLAY_TO_CLIENT)
                .decoder(ManaAmountS2C::new)
                .encoder(ManaAmountS2C::toBytes)
                .consumerMainThread(ManaAmountS2C::handle)
                .add();

        net.messageBuilder(EffectS2C.class, id(), NetworkDirection.PLAY_TO_CLIENT)
                .decoder(EffectS2C::new)
                .encoder(EffectS2C::toBytes)
                .consumerMainThread(EffectS2C::handle)
                .add();
    }

    public static <MSG> void sendToServer(MSG message) {
        INSTANCE.sendToServer(message);
    }

    public static <MSG> void sendToPlayer(MSG message, ServerPlayer player) {
        INSTANCE.send(PacketDistributor.PLAYER.with(() -> player), message);
    }

    public static void sendToClose(EffectS2C message, ServerLevel level) {
        for (ServerPlayer p : level.getPlayers(Predicate.not(ServerPlayer::hasDisconnected)).stream().toList()) {
            if (p.position().subtract(message.vector1).length() <= ConfigServer.C_BROADCAST_RANGE.get()) {
                INSTANCE.send(PacketDistributor.PLAYER.with(() -> p), message);
            }
        }
    }
}
