package com.jenny.magic.networking.packets;

import com.jenny.magic.particles.effects;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.world.phys.Vec3;
import net.minecraftforge.network.NetworkEvent;

import java.util.function.Supplier;

public class EffectS2C {
    private final effects.EFFECT effectID;
    public final Vec3 vector1;

    public EffectS2C(effects.EFFECT effectID, Vec3 origin) {
        this.effectID = effectID;
        this.vector1 = origin;
    }

    public EffectS2C(FriendlyByteBuf buf) {
        this.effectID = effects.EFFECT.values()[buf.getByte(2)];
        this.vector1 = new Vec3(buf.getFloat(3), buf.getFloat(7), buf.getFloat(11));
    }

    public void toBytes(FriendlyByteBuf buf) {
        buf.writeByte(0);
        buf.writeByte(this.effectID.ordinal());
        buf.writeFloat((float) vector1.x);
        buf.writeFloat((float) vector1.y);
        buf.writeFloat((float) vector1.z);
    }

    public boolean handle(Supplier<NetworkEvent.Context> supplier) {
        NetworkEvent.Context context = supplier.get();
        context.enqueueWork(() -> {
            effects.executeEffect(this.effectID, this.vector1);
        });
        return true;
    }
}
