package com.jenny.magic.networking.packets;

import com.jenny.magic.mana.ManaClient;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.network.NetworkEvent;

import java.util.function.Supplier;

public class ManaAmountS2C {
    private final int mana;

    public ManaAmountS2C(int mana) {
        this.mana = mana;
    }

    public ManaAmountS2C(FriendlyByteBuf buf) {
        this.mana = buf.getByte(2);
    }

    public void toBytes(FriendlyByteBuf buf) {
        buf.writeByte(0);
        buf.writeByte(this.mana);
    }

    public boolean handle(Supplier<NetworkEvent.Context> supplier) {
        NetworkEvent.Context context = supplier.get();
        context.enqueueWork(() -> {
            ManaClient.mana = this.mana;
        });
        return true;
    }
}
