package com.jenny.magic.particles;

import net.minecraft.client.Minecraft;
import net.minecraft.core.particles.ParticleType;
import net.minecraft.core.particles.SimpleParticleType;
import net.minecraftforge.client.event.RegisterParticleProvidersEvent;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegistryObject;

import static com.jenny.magic.Magic.MODID;

@Mod.EventBusSubscriber(modid = MODID, bus = Mod.EventBusSubscriber.Bus.MOD)
public class particles {
    public static final DeferredRegister<ParticleType<?>> PARTICLES = DeferredRegister.create(ForgeRegistries.PARTICLE_TYPES, MODID);

    public static final RegistryObject<SimpleParticleType> PARTICLE_HEALTH =
            PARTICLES.register("particle_health", () -> new SimpleParticleType(true));
    public static final RegistryObject<SimpleParticleType> PARTICLE_FLYING_RED =
            PARTICLES.register("particle_flying_red", () -> new SimpleParticleType(true));
    public static final RegistryObject<SimpleParticleType> PARTICLE_HIT_RED =
            PARTICLES.register("particle_hit_red", () -> new SimpleParticleType(true));

    public static void register(IEventBus bus) {
        PARTICLES.register(bus);
    }

    @SubscribeEvent
    public static void registerParticleFactories(final RegisterParticleProvidersEvent event) {
        Minecraft.getInstance().particleEngine.register(PARTICLE_HEALTH.get(), BasicParticle.Provider::new);
        Minecraft.getInstance().particleEngine.register(PARTICLE_FLYING_RED.get(), FallingParticle.Provider::new);
        Minecraft.getInstance().particleEngine.register(PARTICLE_HIT_RED.get(), FallingParticle.Provider::new);
    }
}
